<script lang="ts" setup>
import type { DynamicComponent } from '@/types/base';
import type { PropType } from 'vue';

const content = defineProps({
  backgroundImage: {
    type: String,
    required: false,
    default: '',
  },
  backgroundColor: {
    type: String,
    required: false,
    default: '',
  },
  components: {
    type: Array as PropType<DynamicComponent<never>[]>,
    required: true,
  },
});
const components = await useDynamicComponents(content.components);
</script>

<template>
  <SlpSection class="background-wrapper">
    <template v-for="(component, index) of components" :key="index">
      <keep-alive>
        <component :is="component.resolvedComponent.default" v-bind="component.componentContent" />
      </keep-alive>
    </template>
  </SlpSection>
</template>

<style lang="scss" scoped>
.background-wrapper {
  overflow-x: clip;
  position: relative;
  &:before {
    content: '';
    position: absolute;
    z-index: -1;
    width: 100%;
    height: 100%;
    top: 0;
    right: 0;
    background-image: url('/images/backgrounds/esg-texture.png');
    background-repeat: no-repeat;
    background-position: 0 20%;
    pointer-events: none;
    @media (min-width: $breakpoint-md) {
      width: 58%;
      background-position: top right;
      background-size: 100% auto;
    }
    @media (min-width: 2000px) {
      width: 60%;
      max-height: 2000px;
      background-size: initial;
    }
  }
}
</style>
